/*
Aref ~ 4096mV kann fr den LTC mit dem T2 (Mode3 noninvert) des C erzeugt werden und einem zustzlichen 
RC-Tiefpass (1kohm + >1F), dann muss OCR2 auf ca.210 +-5 abgeglichen werden, weil AREF beim messen leicht einbricht.
ideal 209/255 = 0.819*5V = 4.098...V; gemessen an AREF ca. 4089-4091mV
;**********Auslesen des LTC1286
.equ	LTCPortX	=Portb
.equ 	LTCddrX		=DDrb
.equ	LTCpinX		=Pinb

;***PIN 
.equ	LTCCLK		=0				;Takterzeugung
.equ	LTCDat		=1				;Daten von Leitung
.equ	nCS			=2				;chipselect/shutdown

.equ	LTC_wertH	=$0070			;
.equ	LTC_wertL	=$0071			;hier steht das ergebniss nach einer messung oder nach mittelwertbildung
*/


;auslesen
LTC_read:
		rcall		LTC_pointerY	;speicherpunkt laden
LTC_read2:
		rcall		LTC_D_aktiv		;chip shutdown->aktiv
		rcall		LTC_D_receive	;daten empfangen
		rcall		LTC_D_deaktiv	;chip aktiv->shutdown
		cpi			yl,LTC_wertH+16	;2x4bytes H:L
		brne		ltc_read2		;sprung wenn
		rcall		mittel_wert		;Mittelwertbildung fr 4 Messwerte
		ret

mittel_wert:
		rcall		LTC_pointerY	;Datenspeicherpunkt laden
		clc							;C lschen
		clr			temp0			;lschen
		clr			temp1			;
		clr			cnt				;divcnt
mittel_wert2:
		ld			temp2,y+		;h laden
		ld			temp3,y+		;l laden
		add			temp1,temp3		;l+l	addieren
		adc			temp0,temp2		;h+h+C	addieren + C
		cpi			yl,LTC_wertH+16	;das ganze 4x2Byte
		brne		mittel_wert2	;sprung
mittel_wert3:
		clc							;C lschen
		lsr			temp0			;h/2
		ror			temp1			;l/2 div
		inc			cnt
		cpi			cnt,$03			;2^3=8
		brne		mittel_wert3
		sts			LTC_wertH,temp0	;
		sts			LTC_wertl,temp1	;
		ret							;

LTC_pointerY:
		ldi			yh,high(LTC_wertH)
		ldi			yl,low(LTC_wertH)
		ret

;********************LTC init********************************	
LTC_init:
		ldi			temp0,(1<<LTCCLK|1<<nCS) ;
		out			LTCddrX,temp0
		ldi			temp0,(1<<LTCDat|1<<nCS) ;LTC Shutdown, Pullup aktivieren auf Datapin
		out			LTCPortX,temp0			
		ret

;************ 2*clk = DOUT = 0
LTC_D_aktiv:
		cbi			LTCPortX,nCS	;chip aktivieren
LTC_D_aktiv1:
		rcall		LTC_Clk			;wandlung setzen siehe S.10 DB
		sbic		LTCpinX,LTCDat	;warten bis pin = 0
		rjmp		LTC_D_aktiv1	;
		ret

LTC_D_deaktiv:
		sbi			LTCPortX,nCS	;chip deaktivieren
LTC_D_deaktiv1:
		rcall		LTC_Clk			;und dann in Powerdown
		rcall		LTC_Clk			;mit 2 mal clock
		ret

;************ Takterzeugung
LTC_Clk:sbi			LTCPortX,LTCCLK	;clock erzeugen
		nop
		nop
		cbi			LTCPortX,LTCCLK	;
		ret

;*********** Daten empfangen
LTC_D_receive:
		clr			cnt				;lschen fr Routine
		clr			temp0			;
		clr			temp1			;
		clc							;C lschen
LTC_D_receive1:
		rcall		LTC_Clk			;1x clock
		sbic		LTCPinX,LTCDat	;pinabfrage auf 1
		sec							;setze Carry
		sbis		LTCPinX,LTCDat	;auf 0
		clc							;lsche Carry
		rol			temp1			;aus dem carry rausrollen
		rol			temp0			;ins 2te register
		inc			cnt				;
		cpi			cnt,$0c			;ganze fr 12bit
		brne		LTC_D_receive1	;wdhlg
		st			y+,temp0		;speicher fr mehrfachmessung
		st			y+,temp1	
		ret

;************************************************************************************
mode3_T2_init:;FastPWM kein toggeln mglich nur Clear/Set, bei erreichen BOTTOM = OCR2 update
		sbi			ddrb,3			;output aktivieren
		ldi			temp0,$d3		;zum Clr/Set muss OCR2-Register beachtet werden um
		out			OCR2,temp0		;____--- oder _------ zu erreichen		
		sts			OCR2s,temp0
		in			temp0,TIMSK
		ori			temp0,(0<<OCIE2|0<<TOIE2);OutputCompareInterrupt deaktiviert
		out			TIMSK,temp0
		ldi			temp0,(1<<WGM21|1<<WGM20|1<<COM21|0<<COM20)	;zum Toggeln COM2x Einstellungen beachten!!!!!!!!!
		out			TCCR2,temp0
		ret

prescaler_T2_on:
		in			temp0,TCCR2
		ori			temp0,(0<<CS22|0<<CS21|1<<CS20) ;schmeit den counter an
		out			TCCR2,temp0
		;sei
		ret
