;************************Unterprogramme******************************
rx:		rcall		data_received	;warte auf daten von PC
		cpi			temp1,'S'		;vergleich auf leerzeichen
		brne		rx				;sonst wenn falsch warte weiter
		ldi			temp1,'*'		;
		rcall		data_transmit	;sende * als ack
		ret

tx:		rcall		wait150ms
		ldi			temp1,'r'
		rcall		data_transmit	;sende T
		ldi			temp1,'d'
		rcall		data_transmit	;sende S
		ldi			temp1,'y'
		rcall		data_transmit	;sende T
		ldi			temp1,$0D
		rcall		data_transmit	;ret
		ldi			temp1,$0A
		rcall		data_transmit	;urn
		ret

;************************uart_init mit RX interrupt**********************
usart_init:
		cbi			ddrd,0
		cbi			ddrd,1
		ldi 		temp0,(0<<URSEL)
		out			UCSRC,temp0
		clr			temp0
		out			UBRRH,temp0
		ldi			temp0,$19					;9600 Baud einstellen PDF S.133 table52
		out 		UBRRL,temp0

		rcall		char_size8					;8 zeichen, 1 stoppbit
		
		ldi			temp0,(0<<U2X|0<<MPCM)		;no DoubleSpeed, no MultiProzComMode
		out			UCSRA,temp0
		
		sei
		ret

char_size5:
		ldi 		temp0,(1<<URSEL|0<<UMSEL|0<<UPM1|0<<UPM0|0<<USBS|0<<UCSZ1|0<<UCSZ0|0<<UCPOL) ;URSEL=1 UCSRC1 or UBRRH0,USBS=1 stoppbits1,
		out 		UCSRC,temp0	
		ldi 		temp0,(0<<RXCIE|0<<TXCIE|0<<UDRIE|1<<RXEN|1<<TXEN|0<<UCSZ2)	;enable RX u TX  <=5bit(UCSZ2=0) 
		out 		UCSRB,temp0	;
		ret						
		
char_size6:
		ldi 		temp0,(1<<URSEL|0<<UMSEL|0<<UPM1|0<<UPM0|0<<USBS|0<<UCSZ1|1<<UCSZ0|0<<UCPOL) ;URSEL=1 UCSRC1 or UBRRH0,USBS=1 stoppbits1,
		out 		UCSRC,temp0	
		ldi 		temp0,(0<<RXCIE|0<<TXCIE|0<<UDRIE|1<<RXEN|1<<TXEN|0<<UCSZ2)	;enable RX u TX  <=6bit(UCSZ2=0) 
		out 		UCSRB,temp0	
		ret												
			
char_size7:
		ldi 		temp0,(1<<URSEL|0<<UMSEL|0<<UPM1|0<<UPM0|0<<USBS|1<<UCSZ1|0<<UCSZ0|0<<UCPOL) ;URSEL=1 UCSRC1 or UBRRH0,USBS=1 stoppbits1,
		out 		UCSRC,temp0		
		ldi 		temp0,(0<<RXCIE|0<<TXCIE|0<<UDRIE|1<<RXEN|1<<TXEN|0<<UCSZ2)	;enable RX u TX  <=7bit(UCSZ2=0) 
		out 		UCSRB,temp0	;
		ret											
		
char_size8:
		ldi 		temp0,(1<<URSEL|0<<UMSEL|0<<UPM1|0<<UPM0|0<<USBS|1<<UCSZ1|1<<UCSZ0|0<<UCPOL) ;URSEL=1 UCSRC1 or UBRRH0,USBS=1 stoppbits1,
		out 		UCSRC,temp0	
		ldi 		temp0,(0<<RXCIE|0<<TXCIE|0<<UDRIE|1<<RXEN|1<<TXEN|0<<UCSZ2)	;enable RX u TX  <=7bit(UCSZ2=0) 
		out 		UCSRB,temp0	
		ret					

char_size9:
		ldi 		temp0,(1<<URSEL|0<<UMSEL|0<<UPM1|0<<UPM0|0<<USBS|1<<UCSZ1|1<<UCSZ0|0<<UCPOL) ;URSEL=1 UCSRC1 or UBRRH0,USBS=1 stoppbits1,
		out 		UCSRC,temp0	
		ldi 		temp0,(0<<RXCIE|0<<TXCIE|0<<UDRIE|1<<RXEN|1<<TXEN|1<<UCSZ2)	;enable RX u TX  <=9bit(UCSZ2=1) 
		out 		UCSRB,temp0	
		ret								

;************************uart_deinit********************************
usart_all_aus:
		clr			temp0
		out			UCSRB,temp0
		out			UCSRC,temp0
		out			UBRRL,temp0
		out			UBRRH,temp0
		ret

usart_ofln:									;wenn unterprogramme nicht 
		clr			temp0					;gestrt werden drfen
		out			UCSRB,temp0				;nur usart offline
		ret

;**********************daten_senden*********************************
INT_UTXC:
		;siehe data_transmit;** man kann in der wartezeit andere sachen erledigen
		;bis der int kommt im INT selbst knnte man ne art daten-lese-schleife implementieren
		;um weitere daten zu senden die dann an temp1>>>UDR weitergegeben werden
		out 		UDR,temp1			; Put LSB data (r17) into buffer, tranceived data
		reti

data_transmit:
		sbis		UCSRA,UDRE			;**
		rjmp		data_transmit		;**
		out 		UDR,temp1			; Put LSB data (r17) into buffer, tranceived data
		ret

;**********************daten_empfangen (polling)**********************
INT_URXC:
		in 			temp1,UDR			; Put data from buffer into r17, received Data
		;siehe data_received;** man kann in der wartezeit andere sachen erledigen
		;bis der int kommt im INT selbst knnte man ne art daten-schreib-schleife implementieren
		;um weitere daten zu empfangen die dann an UDR>>>temp1 weitergegeben werden
		reti

data_received:
		sbis		UCSRA,RXC			;**
		rjmp		data_received		;**
		in 			temp1,UDR			; Put data from buffer into r17, received Data
		ret

;********************DatenRegisterLeereInterrupt***********************
INT_UDRE:
		;SOLANGE dieses register leer ist wird diese routine aufgerufen
		;also eigentlich immer wenn UDR=0
		reti
